#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    // ios_base::sync_with_stdio(0);
    // cin.tie(0), cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}

constexpr int MAXN = 1e3 + 1, MOD = 1e9 + 7;

int d[4 * MAXN];

void build(int v, int l, int r, vector<int> &a) {
    if (l + 1 == r) {
        d[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m, a);
    build(2 * v + 2, m, r, a);
    d[v] = max(d[2 * v + 1], d[2 * v + 2]);
}

void update(int v, int l, int r, int indx, int x) {
    if (l + 1 == r) {
        d[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (indx < m) {
        update(2 * v + 1, l, m, indx, x);
    } else {
        update(2 * v + 2, m, r, indx, x);
    }
    d[v] = max(d[2 * v + 1], d[2 * v + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return d[v];
    }
    int m = (l + r) / 2;
    return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

vector<int> p, sz;

int get(int v) {
    if (p[v] == v) {
        return v;
    }
    return p[v] = get(p[v]);
}

void merge(int v, int u) {
    v = get(v);
    u = get(u);
    if (v == u) return;
    if (sz[v] < sz[u]) swap(v, u);
    sz[v] += sz[u];
    p[u] = v;
}

void solve() {
    int n;
    cin >> n;
    vector<int> h(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    p.resize(n);
    sz.resize(n);
    for (int i = 0; i < n; ++i) {
        sz[i] = 1;
        p[i] = i;
    }
    build(0, 0, n, h);
    vector<ll> ans(n);
    for (int i = 0; i < n - 1; i++) {
        int k;
        cin >> k;
        int cnt = 0;
        int first = -1, second = -1;
        for (int j = 0; j < n - 1; ++j) {
            if (get(j) != get(j + 1)) cnt++;
            if (cnt == k - 1) {
                first = j + 1;
            }
            if (cnt == k + 1) {
                second = j;
            }
        }
        if (second == -1) {
            second = n - 1;
        }

        for (int j = first; j <= second; ++j) {
            int l = get(0, 0, n, first, j + 1);
            int r = get(0, 0, n, j, second + 1);
            ans[j] = min(l, r) - h[j];
            if (j + 1 <= second) {
                merge(j, j + 1);
            }
        }
        ll sum = 0;
        for (int j = 0; j < n; ++j) {
            if (j + 1 == n || j + 1 < n && get(j) != get(j + 1)) {
                cout << sum + ans[j] << '\n';
                sum = 0;
            } else {
                sum += ans[j];
            }
        }
    }
}

//
// ll dp[MAXN][4];
//
// void solve() {
//     int n, k;
//     cin >> n >> k;
//     if (k == 1) {
//         vector<int> a(n);
//         for (int i = 0; i < n; ++i) {
//             cin >> a[i];
//         }
//         cout << 1 << '\n';
//         return;
//     }
//     // if (k == 3) {
//     //     cout << 24 << '\n';
//     //     return;
//     // }
//     vector<int> a(n);
//     for (int i = 0; i < n; ++i) {
//         cin >> a[i];
//     }
//     if (a[0] == 0) {
//         dp[0][0] = 1;
//     } else if (a[0] == 1) {
//         dp[0][1] = 1;
//         dp[0][2] = 1;
//     } else {
//         dp[0][3] = 1;
//     }
//     for (int i = 1; i < n; ++i) {
//         if (a[i] == 0) {
//             dp[i][0] += dp[i - 1][0] + dp[i - 1][2];
//         } else if (a[i] == 1) {
//             dp[i][0] += dp[i - 1][1] + dp[i - 1][3];
//             dp[i][1] += dp[i - 1][0] + dp[i - 1][2];
//             dp[i][2] += dp[i - 1][0] + dp[i - 1][2];
//         } else {
//             dp[i][1] += dp[i - 1][1] + dp[i - 1][3];
//             dp[i][2] += dp[i - 1][1] + dp[i - 1][3];
//             dp[i][3] += dp[i - 1][0] + dp[i - 1][2];
//         }
//         dp[i][0] %= MOD;
//         dp[i][1] %= MOD;
//         dp[i][2] %= MOD;
//         dp[i][3] %= MOD;
//     }
//     if (a.back() == 0) {
//         cout << dp[n - 1][0] << '\n';
//     } else if (a.back() == 1) {
//         cout << dp[n - 1][1] + dp[n - 1][2] << '\n';
//     } else {
//         cout << dp[n - 1][3] << '\n';
//     }
// }
