#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("Input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}

constexpr int MAXN = 1e3 + 1, MOD = 1e9 + 7;

int d[4 * MAXN];

void build(int v, int l, int r, vector<int> &a) {
    if (l + 1 == r) {
        d[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m, a);
    build(2 * v + 2, m, r, a);
    d[v] = max(d[2 * v + 1], d[2 * v + 2]);
}

void update(int v, int l, int r, int indx, int x) {
    if (l + 1 == r) {
        d[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (indx < m) {
        update(2 * v + 1, l, m, indx, x);
    } else {
        update(2 * v + 2, m, r, indx, x);
    }
    d[v] = max(d[2 * v + 1], d[2 * v + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return d[v];
    }
    int m = (l + r) / 2;
    return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

vector<int> p, sz;

int get(int v) {
    if (p[v] == v) {
        return v;
    }
    return p[v] = get(p[v]);
}

void merge(int v, int u) {
    v = get(v);
    u = get(u);
    if (v == u) return;
    if (sz[v] < sz[u]) swap(v, u);
    sz[v] += sz[u];
    p[u] = v;
}

void solve() {
    int n;
    cin >> n;
    vector<int> h(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    p.resize(n);
    sz.resize(n);
    for (int i = 0; i < n; ++i) {
        sz[i] = 1;
        p[i] = i;
    }
    build(0, 0, n, h);
    vector<ll> ans(n);
    for (int i = 0; i < n - 1; i++) {
        int k;
        cin >> k;
        int cnt = 0;
        int first = -1, second = -1;
        for (int j = 0; j < n; ++j) {
            if (cnt == k - 1 && first == -1) {
                first = j;
            }
            if (cnt == k + 1 && second == -1) {
                second = j - 1;
            }
            if (j + 1 < n && get(j) != get(j + 1)) cnt++;
        }
        // if (first == -1) first = 0;
        if (second == -1) {
            second = n - 1;
        }
        ll sum = 0;

        for (int j = first; j <= second; ++j) {
            int l = get(0, 0, n, first, j + 1);
            int r = get(0, 0, n, j, second + 1);
            ans[j] = min(l, r) - h[j];
            sum += ans[j];
            if (j + 1 <= second) {
                merge(j, j + 1);
            }
        }
        cout << sum << '\n';
    }
}
